Page Menu
Home
FreeBSD
Search
Configure Global Search
Log In
Files
F116001262
D24303.id70277.diff
No One
Temporary
Actions
View File
Edit File
Delete File
View Transforms
Subscribe
Mute Notifications
Flag For Later
Award Token
Size
4 KB
Referenced Files
None
Subscribers
None
D24303.id70277.diff
View Options
Index: tests/sys/netinet/Makefile
===================================================================
--- tests/sys/netinet/Makefile
+++ tests/sys/netinet/Makefile
@@ -9,7 +9,7 @@
so_reuseport_lb_test \
socket_afinet
-ATF_TESTS_SH= fibs_test redirect divert forward output
+ATF_TESTS_SH= carp fibs_test redirect divert forward output
PROGS= udp_dontroute tcp_user_cookie
Index: tests/sys/netinet/carp.sh
===================================================================
--- /dev/null
+++ tests/sys/netinet/carp.sh
@@ -0,0 +1,120 @@
+# $FreeBSD$
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2020 Kristof Provost <kp@FreeBSD.org>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+. $(atf_get_srcdir)/../common/vnet.subr
+
+atf_test_case "basic_v4" "cleanup"
+basic_v4_head()
+{
+ atf_set descr 'Basic CARP test (IPv4)'
+ atf_set require.user root
+}
+
+basic_v4_body()
+{
+ if ! kldstat -q -m carp; then
+ atf_skip "This test requires carp"
+ fi
+
+ vnet_init
+ bridge=$(vnet_mkbridge)
+ epair_one=$(vnet_mkepair)
+ epair_two=$(vnet_mkepair)
+
+ vnet_mkjail one ${bridge} ${epair_one}a ${epair_two}a
+ vnet_mkjail two ${epair_one}b
+ vnet_mkjail three ${epair_two}b
+
+ jexec one ifconfig ${bridge} 192.0.2.4/29 up
+ jexec one ifconfig ${bridge} addm ${epair_one}a addm ${epair_two}a
+ jexec one ifconfig ${epair_one}a up
+ jexec one ifconfig ${epair_two}a up
+
+ jexec two ifconfig ${epair_one}b 192.0.2.202/29 up
+ jexec two ifconfig ${epair_one}b add vhid 1 192.0.2.1/29
+
+ jexec three ifconfig ${epair_two}b 192.0.2.203/29 up
+ jexec three ifconfig ${epair_two}b add vhid 1 192.0.2.1/29
+
+ sleep 3
+
+ atf_check -s exit:0 -o ignore jexec one ping -c 3 192.0.2.1
+}
+
+basic_v4_cleanup()
+{
+ vnet_cleanup
+}
+
+atf_test_case "basic_v6" "cleanup"
+basic_v6_head()
+{
+ atf_set descr 'Basic CARP test (IPv6)'
+ atf_set require.user root
+}
+
+basic_v6_body()
+{
+ if ! kldstat -q -m carp; then
+ atf_skip "This test requires carp"
+ fi
+
+ vnet_init
+ bridge=$(vnet_mkbridge)
+ epair_one=$(vnet_mkepair)
+ epair_two=$(vnet_mkepair)
+
+ vnet_mkjail one ${bridge} ${epair_one}a ${epair_two}a
+ vnet_mkjail two ${epair_one}b
+ vnet_mkjail three ${epair_two}b
+
+ jexec one ifconfig ${bridge} inet6 2001:db8::0:4/64 up no_dad
+ jexec one ifconfig ${bridge} addm ${epair_one}a addm ${epair_two}a
+ jexec one ifconfig ${epair_one}a up
+ jexec one ifconfig ${epair_two}a up
+
+ jexec two ifconfig ${epair_one}b inet6 2001:db8::1:2/64 up no_dad
+ jexec two ifconfig ${epair_one}b inet6 add vhid 1 2001:db8::0:1/128
+
+ jexec three ifconfig ${epair_two}b inet6 2001:db8::1:3/64 up no_dad
+ jexec three ifconfig ${epair_two}b inet6 add vhid 1 2001:db8::0:1/128
+
+ sleep 3
+
+ atf_check -s exit:0 -o ignore jexec one ping6 -c 3 2001:db8::0:1
+}
+
+basic_v6_cleanup()
+{
+ vnet_cleanup
+}
+
+atf_init_test_cases()
+{
+ atf_add_test_case "basic_v4"
+ atf_add_test_case "basic_v6"
+}
File Metadata
Details
Attached
Mime Type
text/plain
Expires
Fri, May 2, 10:26 AM (17 h, 48 m)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
17904487
Default Alt Text
D24303.id70277.diff (4 KB)
Attached To
Mode
D24303: carp tests: Basic functionality test
Attached
Detach File
Event Timeline
Log In to Comment